## ros-noetic-skyway 0.0.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(skyway)
add_compile_options(-std=c++14)

include(ExternalProject)

SET(VENDOR_DIR ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/vendor)

find_package(catkin REQUIRED COMPONENTS
        message_generation
        roscpp
        std_msgs
        pluginlib
        )

add_service_files(
        DIRECTORY srv
        FILES SkyWayControl.srv SkyWayEvents.srv
)

generate_messages(
        DEPENDENCIES std_msgs
)

catkin_package(
        INCLUDE_DIRS include
        LIBRARIES ${PROJECT_NAME}_plugin
        CATKIN_DEPENDS std_msgs message_runtime
)

include_directories(
        include
        ${catkin_INCLUDE_DIRS}
        ${VENDOR_DIR}/fruit/include
        ${VENDOR_DIR}/rapidjson/include
)

###########
## Build ##
###########

# add DI framework
SET(FRUIT_LIB_FILE ${VENDOR_DIR}/fruit/src/libfruit.a)
ExternalProject_Add(${PROJECT_NAME}_fruit
        URL https://github.com/google/fruit/archive/refs/tags/v3.7.1.zip
        UPDATE_COMMAND ""
        INSTALL_COMMAND ""
        SOURCE_DIR ${VENDOR_DIR}/fruit
        DOWNLOAD_DIR ${VENDOR_DIR}/fruit
        BINARY_DIR ${VENDOR_DIR}/fruit
        CMAKE_ARGS -DCMAKE_BUILD_TYPE=Release -DBUILD_SHARED_LIBS=Off
        UPDATE_DISCONNECTED 1
        )

# add json library
ExternalProject_Add(${PROJECT_NAME}_rapidjson
        URL https://github.com/Tencent/rapidjson/archive/refs/tags/v1.1.0.zip
        UPDATE_COMMAND ""
        CONFIGURE_COMMAND ""
        BUILD_COMMAND ""
        INSTALL_COMMAND ""
        SOURCE_DIR ${VENDOR_DIR}/rapidjson
        DOWNLOAD_DIR ${VENDOR_DIR}/rapidjson
        BINARY_DIR ${VENDOR_DIR}/rapidjson
        UPDATE_DISCONNECTED 1
        )

# add skyway library
if("$ENV{ROS_DISTRO}" STREQUAL "noetic")
    message(STATUS "Download library for noetic")
    SET(SKYWAY_LIB_FILE ${VENDOR_DIR}/libskyway_20.04.a)
    ExternalProject_Add(${PROJECT_NAME}_skyway
            URL https://github.com/ntt-t3/skyway_for_ros/releases/download/lib_v0.0.1/libskyway_20.04.a
            UPDATE_COMMAND ""
            CONFIGURE_COMMAND ""
            BUILD_COMMAND ""
            INSTALL_COMMAND ""
            DOWNLOAD_DIR ${VENDOR_DIR}
            BINARY_DIR ${VENDOR_DIR}
            UPDATE_DISCONNECTED 1
            DOWNLOAD_NO_EXTRACT 1
            )
endif()

if("$ENV{ROS_DISTRO}" STREQUAL "melodic")
    message(STATUS "Download library for melodic")
    SET(SKYWAY_LIB_FILE ${VENDOR_DIR}/libskyway_18.04.a)
    ExternalProject_Add(${PROJECT_NAME}_skyway
            URL https://github.com/ntt-t3/skyway_for_ros/releases/download/lib_v0.0.1/libskyway_18.04.a
            UPDATE_COMMAND ""
            CONFIGURE_COMMAND ""
            BUILD_COMMAND ""
            INSTALL_COMMAND ""
            DOWNLOAD_DIR ${VENDOR_DIR}
            BINARY_DIR ${VENDOR_DIR}
            UPDATE_DISCONNECTED 1
            DOWNLOAD_NO_EXTRACT 1
            )
endif()


set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES ${VENDOR_DIR})

add_executable(${PROJECT_NAME}
        src/main.cpp
        src/ffi.cpp
        src/ffi_bridge.cpp
        src/router.cpp
        src/plugin_router/binary_plugin_router.cpp
        src/plugin_router/json_plugin_router.cpp
        src/plugin_router/plugin_router_factory.cpp
        src/plugin_router/string_plugin_router.cpp
        src/presentation/control_service.cpp
        src/presentation/events_service.cpp
        src/socket/udp_socket.cpp
        )

add_dependencies(${PROJECT_NAME}
        ${${PROJECT_NAME}_EXPORTED_TARGETS}
        ${catkin_EXPORTED_TARGETS}
        ${PROJECT_NAME}_fruit
        ${PROJECT_NAME}_rapidjson
        ${PROJECT_NAME}_skyway)

target_link_libraries(${PROJECT_NAME}
        ${catkin_LIBRARIES}
        ${SKYWAY_LIB_FILE}
        ${FRUIT_LIB_FILE}
        crypto
        ssl
        pthread
        dl
        rt
        )

add_library(${PROJECT_NAME}_plugin
        src/plugin/samples/binary_loopback.cpp
        src/plugin/samples/json_loopback.cpp
        src/plugin/samples/string_loopback.cpp
        src/plugin/samples/string_pub_sub.cpp
        src/plugin/skyway_plugin.cpp)

add_dependencies(${PROJECT_NAME}_plugin
        ${${PROJECT_NAME}_EXPORTED_TARGETS}
        ${catkin_EXPORTED_TARGETS}
        ${PROJECT_NAME}
        ${PROJECT_NAME}_rapidjson
        ${PROJECT_NAME}_skyway)

install(TARGETS ${PROJECT_NAME} ${PROJECT_NAME}_plugin
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
        DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})

install(FILES ${PROJECT_NAME}_plugin.xml
        DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

if (CATKIN_ENABLE_TESTING)
    find_package(rostest REQUIRED)
    add_rostest_gtest(${PROJECT_NAME}_test_node test/unit_test.test
            test/test_main.cpp
            test/plugin_router/binary_plugin_router_test.cpp
            test/plugin_router/json_plugin_router_test.cpp
            test/plugin_router/plugin_router_factory_test.cpp
            test/plugin_router/string_plugin_router_test.cpp
            test/socket/udp_socket_test.cpp
            src/plugin_router/binary_plugin_router.cpp
            src/plugin_router/json_plugin_router.cpp
            src/plugin_router/plugin_router_factory.cpp
            src/plugin_router/string_plugin_router.cpp
            src/presentation/control_service.cpp
            src/presentation/events_service.cpp
            src/socket/udp_socket.cpp
            )
    add_dependencies(${PROJECT_NAME}_test_node
            ${${PROJECT_NAME}_EXPORTED_TARGETS}
            ${catkin_EXPORTED_TARGETS}
            ${PROJECT_NAME}_fruit
            ${PROJECT_NAME}_rapidjson
            ${PROJECT_NAME}_skyway)
    target_link_libraries(${PROJECT_NAME}_test_node
            ${catkin_LIBRARIES}
            ${SKYWAY_LIB_FILE}
            ${FRUIT_LIB_FILE}
            crypto
            ssl
            pthread
            dl
            rt
            )
endif ()

=== examples/gstreamer_launcher/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(gstreamer_launcher)

find_package(catkin REQUIRED COMPONENTS
  roscpp
  rospy
  std_msgs
  message_generation
)

################################################
## Declare ROS messages, services and actions ##
################################################

add_service_files(
   FILES
   GStreamerLauncher.srv
)

generate_messages(
  DEPENDENCIES
  std_msgs
)

###################################
## catkin specific configuration ##
###################################

catkin_package(
#  INCLUDE_DIRS include
#  LIBRARIES gstreamer_launcher
#  CATKIN_DEPENDS rospy std_msgs
#  DEPENDS system_lib
)

=== examples/gstreamer_launcher/requirements.txt ===
psutil==5.9.4

=== examples/skyway_for_ros_examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
project(skyway_for_ros_examples)

catkin_package()

find_package(catkin REQUIRED COMPONENTS
  roscpp
  rospy
  skyway
  std_msgs
)

=== examples/skyway_for_ros_examples/requirements.txt ===
black==22.8.0

=== debian/changelog ===
ros-noetic-skyway (0.0.2-1focal) focal; urgency=high

  * Output logs when loading and unloading plugins

 -- Toshiya Nakakura <t.nakakura@ntt.com>  Wed, 05 Apr 2023 15:00:00 -0000

ros-noetic-skyway (0.0.1-1focal) focal; urgency=high

  first release

 -- Nakakura <t.nakakura@ntt.com>  Tue, 28 Mar 2023 15:00:00 -0000

=== debian/control ===
Source: ros-noetic-skyway
Section: misc
Priority: optional
Maintainer: Toshiya Nakakura <t.nakakura@ntt.com>
Build-Depends: debhelper (>= 9.0.0), libgtest-dev <!nocheck>, ros-noetic-catkin, ros-noetic-message-generation, ros-noetic-pluginlib, ros-noetic-roscpp, ros-noetic-rostest <!nocheck>, ros-noetic-std-msgs
Homepage: https://github.com/ntt-t3/skyway_for_ros
Standards-Version: 3.9.2

Package: ros-noetic-skyway
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-message-runtime, ros-noetic-pluginlib, ros-noetic-roscpp, ros-noetic-std-msgs
Description: Package for using SkyWay from ROS

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-skyway//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
